import { takeLatest, SagaIterator } from 'redux-saga';
import { call, Effect, fork, put } from 'redux-saga/effects';

import Action from 'commons/redux/Action';

import Member from 'member/api/model/Member';
import actions from '../action';
import actionTypes from '../action/type';
import SigninPayload from '../payload/SigninPayload';

const apiSignin = (signinId: string, signinPw: string): Promise<Member> => {
  return new Promise<Member>(resolve => {
    setTimeout(() => {
      let member: Member = {
        email: 'crusader@loafle.com',
        name: 'crusader',
        phone: '02-900-9000',
        companyName: 'LOAFLE',
      };

      resolve(member);
    },         1000);
  });
};

function* signin(action: Action<SigninPayload>): Iterable<Effect> {
  try {
    const {signinId, signinPw} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });

    const member = yield call(apiSignin, signinId, signinPw);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(actions.requestSuccess(member));
  } catch (e) {
    yield put(actions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchSignin(): Iterable<SagaIterator> {
  yield takeLatest(actionTypes.REQUEST, signin);
}
